=== debian/changelog ===
ros-one-pinocchio (3.9.0-19noble.20260226.2057) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Thu, 26 Feb 2026 20:57:17 +0000
